let app = getApp();
let getAuthLoading = false;
Page({
  data: {
    userAuth: false,
    stepAuth: false
  },
  
  onLoad() {
    this.setData({
      userAuth: app.globalData.userAuth,
      stepAuth: app.globalData.stepAuth
    });
  },

  getUserAuth(event) {
    if (getAuthLoading) return;
    getAuthLoading = true;
    if (event.detail.errMsg === 'getUserInfo:ok') {
      console.log('getUserAuth:ok', event.detail)
      app.globalData.userAuth = true;
      this.setData({
        userAuth: true
      });
      this.checkAuth();
    } else {
      console.log('getUserAuth:fail', event)
      wx.showModal({
        content: '授权失败，请重新点击按钮发起授权',
        showCancel: false
      });
    }
    setTimeout(() => {
      getAuthLoading = false;
    }, 100);
  },

  getStepAuth() {
    if (getAuthLoading) return;
    getAuthLoading = true;
    wx.authorize({
      scope: 'scope.werun',
      success:() => {
        app.globalData.stepAuth = true;
        this.setData({
          stepAuth: true
        });
        this.checkAuth();
      },
      fail:() => {
        // 调起用户授权窗口失败，因为用户曾经拒绝过，而且在这里不能直接去到openSetting页，需要通过一个弹窗中转过去
        wx.showModal({
          content: '授权失败，请在接下来的页面中同意授权',
          showCancel: false,
          success:() => {
            wx.openSetting({
              success:(res) => {
                if (res.authSetting['scope.userInfo']) {
                  app.globalData.userAuth = true;
                  this.setData({
                    userAuth: true
                  });
                } else {
                  app.globalData.userAuth = false;
                  this.setData({
                    userAuth: false
                  });
                }
                if (res.authSetting['scope.werun']) {
                  app.globalData.stepAuth = true;
                  this.setData({
                    stepAuth: true
                  });
                } else {
                  app.globalData.stepAuth = false;
                  this.setData({
                    stepAuth: false
                  });
                }
                this.checkAuth();
              }
            });
          }
        });
      },
      complete: () => {
        setTimeout(() => {
          getAuthLoading = false;
        }, 100);
      }
    });
  },
  
  checkAuth() {
    if (app.globalData.userAuth && app.globalData.stepAuth) {
      wx.navigateBack({
        delta: 1
      });
    }
  }
})